//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Nurse, NurseDocument } from '../Nurse';
import { NurseService } from '../NurseService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Nurse')
@UseBefore(checkApiDisabled(NurseBaseController))
export class NurseBaseController extends BaseController {
    protected model: Model<NurseDocument>;

    protected static readonly _objName: string = 'Nurse';
    protected static readonly _apiDisabled: boolean = false;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.NURSE.READ,
        create: MEDICALPRACTICE_PERMISSIONS.NURSE.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.NURSE.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.NURSE.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(nurseService: NurseService) {
        super(Nurse, nurseService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(NurseBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async getAllNurse(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(NurseBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async getOneNurse(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(NurseBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async postNurse(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(NurseBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async patchNurse(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(NurseBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async deleteNurse(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsNurse(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(NurseBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async getCsvExportNurse(@Res() response, @QueryParams() query) {
        response.attachment(`${NurseBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(NurseBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async getXlsxExportNurse(@Res() response, @QueryParams() query) {
        response.attachment(`${NurseBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(NurseBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.NURSE.READ))
    @UseBefore(authenticated)
    public async getPdfExportNurse(@Res() response, @QueryParams() query) {
        response.attachment(`${NurseBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
